{{ ---------------------------------------------------------------------------------------------------------

Hive-Computer-Projekt

Name            : aslide
Chip            : Regnatix-Code 
Version         : 0.1
Dateien         : aslide.spin                             

Beschreibung    : Zeigt ASCII Slides von SD Karte an.
                  Datei in den eRAM eingelesen und folgend wieder auf
                  dem Bildschirm ausgegeben.
                  Beim @ Zeichen erfolgt eine Pause und
                  anschlieend ein Clear Screen

Eigenschaften   : aslide <quelle> 

Logbuch         :

30.07.2009      - erste version



--------------------------------------------------------------------------------------------------------- }}



OBJ
        ios: "ios"

CON

_CLKMODE     = XTAL1 + PLL16X
_XINFREQ     = 5_000_000

PARALEN      = 32
VAR

byte    parastr1[PARALEN]

long    dlen                                            'dateilnge
long    count                                           'zhler
long    i

PUB main

  ios.start
  ios.parastart
  parastr1[0] := 0
  rdpara1
  rdfile
  'repeat
  wrfile
  ios.paradel
  ios.stop

PUB rdfile | status,len,char,curpos
  
  dlen   := 0                                           'dateilnge auf 0 setzen
  len    := ios#SYSVAR                                  'maximale dateigre
  status := ios.sdopen("r",@parastr1)                   'datei ffnen
  if status > 0                                         'fehler beim ffnen der datei?
    ios.print(@err2)
    ios.printdec(status)
    ios.printnl
  if status == 0
    ios.print(@msg5)
    curpos := ios.curgetx                               'cursorposition x merken
    ios.curoff
    repeat i from 0 to len
      char := ios.sdgetc
      if ios.sdeof == 1                                 'eof erreicht?
        quit
      ios.ram_write(char,i)
      dlen++
      ios.cursetx(curpos)                               'position setzen
      ios.printdec(dlen)
      ios.print(@msg9)
    ios.curon
    ios.sdclose
    ios.print(@msg8)
    ios.printnl

PUB wrfile | char

  ios.curoff
  ios.printcls
  repeat i from 0 to dlen-1
    char := ios.ram_read(i)
    if char == chr1
      waitcnt(100_000_000+cnt)
      ios.printcls
    else
      ios.printchar(char)
  ios.curon   


PUB rdpara1
  if ios.paranext(@parastr1)                            'parameter quelldatei einlesen
    ios.print(@msg1)
    ios.print(@parastr1)
    ios.printnl
  else
    ios.print(@err1)
    ios.printnl
    return

DAT

chr1          byte  64
msg1          byte  "Quelldatei : ", 0
msg5          byte  "Datei einlesen : ", 0
msg8          byte  " ok ", 0
msg9          byte  " Bytes ", 0

err1          byte  "Keine Quelldatei angegeben!",13,0
err2          byte  "Quelldatei kann nicht geffnet werden! : ", 0
err4          byte  "Datei zu gro!", 0